并查集巧妙用法(codeforces)C. Destroying Array

C. Destroying Array


题意:对样例进行分析:

,n == 4,数组是1 3 2 5,然后下一行就是每一个数就得输出,代表的是删除数组中的第几个数,然后在删除后的数组中找到分成的段的和最大。


思路:当时一看到就想到了线段树,可以并不会线段树。。。

后面看到大神的博客,用并查集倒着写!,高手呀;

倒着写就是对第三行的数倒着操作,相当于每次都往数组中的这个位置插入这个元素,然后用并查集进行合并,然后判断最大的哪一段输出;


#include<bits/stdc++.h>
using namespace std;
const int maxn  = 100000 + 10;
typedef __int64 ll;

ll n;
ll pre[maxn];
ll a[maxn],b[maxn];
bool vis[maxn];
ll value[maxn];
void Init()
{
    for(ll i = 1;i <= n ;i ++)
    {
        pre[i] = i;
        value[i] = a[i];
    }
}
ll finds(ll x)
{
    ll r = x;
    while(r != pre[r])
    {
        r = pre[r];
    }
    ll i = x, j;
    while(i != r)
    {
        ll j = pre[i];
        pre[i] = r;
        i = j;
    }
    return r;
}
void join(ll x,ll y)
{
    ll fx = finds(x), fy = finds(y);
    if(fx != fy)
    {
        pre[fx] = fy;
        value[fy] += value[fx];
    }
}
int main()
{
    while( ~ scanf("%lld",&n) )
    {
        memset(vis,false,sizeof(vis));
        for(ll i = 1; i <= n ;i ++)
        {
            scanf("%lld",&a[i]);
        }
        for(ll i = 1; i <= n ; i ++)
        {
            scanf("%lld",&b[i]);
        }
        Init();
        stack<ll>s;
        s.push(0);
        ll ans = 0;
        for(ll i = n ;i >= 2 ;i --)
        {
            ll poll = b[i];
            vis[poll] = true;
            if(vis[poll - 1])
            {
                join(poll,poll - 1);

            }
            if(vis[poll + 1])
            {
                join(poll, poll + 1);
            }
            ll temp = value[finds(poll)];
            if(temp > ans )
                ans = temp;
//            cout << poll << " " << ans <<endl;
            s.push(ans);
        }
        while( ! s.empty())
        {
            cout << s.top() <<endl;
            s.pop();
        }
    }
    return 0;
}


下面顺便副上这次的A,B题吧:


#include <bits/stdc++.h>
using namespace std;
int main()
{
    int num;
    cin >> num;
    string str;
    cin >> str;
    int h = (str[0] - '0') * 10 + str[1] - '0';
    int m = (str[3] - '0') * 10 + str[4] - '0';
    if(num == 12)
    {
        if(h == 0)
            h = 1;
        else if(h > 12)
        {
            if(h % 10 == 0)
            {
                h = 10;
            }
            else
            {
                while(h > 10)
                {
                    h -= 10;
                }
            }
        }
    }
    else
    {
        while(h > 23)
        {
            h -= 10;
        }
    }
    while(m >= 60)
    {
        m -= 10;
    }
    if(h < 10)
    {
        cout << 0;
    }
    cout << h
         << ":";
    if(m < 10)
    {
        cout << 0;
    }
    cout << m << endl;;
}


B. Verse Pattern


#include<bits/stdc++.h>
using namespace std;
const int maxn  = 100000 + 10;
typedef __int64 ll;
char s[maxn/100][maxn/100];
int num[maxn/100];
int n;
int solve()
{
    for(int i = 1; i <= n;i ++)
    {
        int len = strlen(s[i]);
        int temp = 0;
        for(int j = 0; j < len ; j ++)
        {
            if(s[i][j] == 'a' || s[i][j] == 'e' ||s[i][j] == 'i' ||s[i][j] == 'o' ||s[i][j] == 'u'||s[i][j] == 'y')
                temp ++;
        }
        if(temp != num[i])
            return 0;
    }
    return 1;
}
int main()
{
    while( ~ scanf("%d",&n) )
    {
        for(int i = 1;i <= n ; i ++)
        {
            scanf("%d",&num[i]);
        }
        getchar();
        for(int i = 1; i <= n ;i ++)
        {
            gets(s[i]);
        }
        if(solve())
            cout << "YES" <<endl;
        else cout << "NO" <<endl;
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
The problem statement can be found at Codeforces website. Approach: Let's start by looking at some examples: - 1, 2, 3, 4, 5 → No moves needed. - 2, 1, 3, 5, 4 → One move needed: swap index 1 and 2. - 5, 4, 3, 2, 1 → Two moves needed: swap index 1 and 5, then swap index 2 and 4. We can observe that in order to minimize the number of moves, we need to sort the array in non-descending order and keep track of the number of swaps we make. We can use bubble sort to sort the array and count the number of swaps. Let's see how bubble sort works: - Start from the first element, compare it with the second element, and swap them if the second element is smaller. - Move to the second element, compare it with the third element, and swap them if the third element is smaller. - Continue this process until the second-to-last element. At this point, the largest element is in the last position. - Repeat the above process for the remaining elements, but exclude the last position. In each iteration of the above process, we can count the number of swaps made. Therefore, the total number of swaps needed to sort the array can be obtained by summing up the number of swaps made in each iteration. Implementation: We can implement the above approach using a simple bubble sort algorithm. Here's the code: - First, we read the input array and store it in a vector. - We define a variable to keep track of the total number of swaps made and set it to 0. - We run a loop from the first element to the second-to-last element. - In each iteration of the above loop, we run another loop from the first element to the second-to-last element minus the current iteration index. - In each iteration of the inner loop, we compare the current element with the next element and swap them if the next element is smaller. - If a swap is made, we increment the total number of swaps made. - Finally, we output the total number of swaps made. Time Complexity: The time complexity of bubble sort is O(n^2). Therefore, the overall time complexity of the solution is O(n^2). Space Complexity: We are using a vector to store the input array. Therefore, the space complexity of the solution is O(n). Let's see the implementation of the solution.

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值